#include "stu.h"

//--------------- алгоритм  Укконена построения суффиксного дерева ----------------
//----------------- построение дерева - приватные методы --------------------------

int stree::make_node( int _pos, int _len ) {
   spos[ sz ] = _pos;
   len[ sz ] = _len;
   return sz++;
}

void stree::go_edge( void ) {
   while( pos > len[ to[ node ][ s[ n - pos ] ] ] ) {
      node = to[ node ][ s[ n - pos ] ];
      pos -= len[ node ];
   }
}

void stree::add_letter( char c ) {
   s[ n++ ] = c;
   pos++;
   int last = 0;
   while( pos > 0 ) {
      go_edge();
      int edge = s[ n - pos ];
      int &v = to[ node ][ edge ];
      int t = s[ spos[ v ] + pos - 1 ];
      if( v == 0 ) {
         v = make_node( n - pos, inf );
         link[ last ] = node;
         last = 0;
      }
      else if( t == c ) {
         link[ last ] = node;
         return;
      }
      else {
         int u = make_node( spos[ v ], pos - 1 );
         to[ u ][ c ] = make_node( n - 1, inf );
         to[ u ][ t ] = v;
         spos[ v ] += pos - 1;
         len[ v ] -= pos - 1;
         v = u;
         link[ last ] = u;
         last = u;
      }
      if( node == 0 )
         pos--;
      else
         node = link[ node ];
   }
}

//---------------------------------------------------------------------------------
