#ifndef STU_H
#define STU_H
#include <bits/stdc++.h>
using namespace std;

class stree {
private:
   static const int inf = 1e9;
   static const int maxn = 1e4;
   char s[ maxn ];
   int node, pos;
   int sz, n;
   int make_node( int, int );
   void go_edge( void );
   void add_letter( char c );
   void image_node( pair< const char, int >& n ) {
//      cout << n.first;
      cout << "<" << n.second << ">" << n.first;
      int i = n.second;
      string se( s );
//      int l = min( (int)se.size() - spos[ i ], len[ i ] ); 
//      int l = len[ i ]; 
      cout << "[" << spos[ i ] << ":" << len[ i ] << "]:" 
           << se.substr( spos[ i ], len[ i ] ) << endl;    
   }
   void put_node( pair< const char, int >& n, int levl ) {
      for( int i = 0; i < levl; i++ ) cout << '\t'; 
      image_node( n );
      int i = n.second;
      if( !to[ i ].empty() )
         show_tree( i, levl + 1 );
   }
public:
   int len[ maxn ], spos[ maxn ], link[ maxn ];
   map< char, int > to[ maxn ];
   inline int nodes( void ) { return sz; }
   stree( string& text ) {
      sz = 1; n = node = pos = 0; len[ 0 ] = inf;
      for( unsigned i = 0; i < text.size(); i++ ) 
         add_letter( text[ i ] );
      for( int i = 0; i < sz; i++ ) 
         len[ i ] = min( (int)strlen( s ) - spos[ i ], len[ i ] );
   }
   void show_internal( void ) {
      cout << "{pos,len,link}: ";
      for( int i = 1; i < sz; i++ ) 
         cout << "{" << i << ":" << spos[ i ] << ","  << len[ i ] << "," << link[ i ] << "} ";
      cout << endl;
      for( int i = 0; i < sz; i++ ) {
         cout << i << ": map size " << to[ i ].size() << " : ";
         for( auto &x : to[ i ] )
            cout << "[" << (char)x.first << "," << x.second << "] ";
         cout << endl;
      }
   }
   void show_tree( int layer = 0, int levl = 0 ) {
      for( auto &n : to[ layer ] )
         put_node( n, levl );
   } 
};

#endif

//   void show_edges
